#define _MT_CSteamID gLua->GetMetaTable(MT_CSteamID::MT_NAME, MT_CSteamID::MT_ID)

namespace MT_CSteamID
{
	const char *MT_NAME = "CSteamID";
	const int MT_ID = 8007;
	
	LUA_FUNCTION(GetAccountID)
	{
		gLua->CheckType(1, MT_ID);

		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);
		
		gLua->PushDouble(cSteamID->GetAccountID());

		return 1;
	}

	LUA_FUNCTION(GetEAccountType)
	{
		gLua->CheckType(1, MT_ID);

		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);

		gLua->PushDouble(cSteamID->GetEAccountType());

		return 1;
	}

	LUA_FUNCTION(GetEUniverse)
	{
		gLua->CheckType(1, MT_ID);

		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);

		gLua->PushDouble(cSteamID->GetEUniverse());

		return 1;
	}

	LUA_FUNCTION(GetUnAccountInstance)
	{
		gLua->CheckType(1, MT_ID);

		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);

		gLua->PushDouble(cSteamID->GetUnAccountInstance());

		return 1;
	}

	LUA_FUNCTION(InstancedSet)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_NUMBER);
		gLua->CheckType(3, GLua::TYPE_NUMBER);
		gLua->CheckType(4, GLua::TYPE_NUMBER);
		gLua->CheckType(5, GLua::TYPE_NUMBER);

		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);
		
		cSteamID->InstancedSet(gLua->GetInteger(2), gLua->GetInteger(3), (EUniverse)gLua->GetInteger(4), (EAccountType)gLua->GetInteger(5));

		return 0;
	}

	LUA_FUNCTION(IsValid)
	{
		gLua->CheckType(1, MT_ID);

		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);

		gLua->Push(cSteamID->IsValid());

		return 1;
	}
	
	LUA_FUNCTION(Render)
	{
		gLua->CheckType(1, MT_ID);

		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);

		gLua->Push(cSteamID->Render());

		return 1;
	}

	LUA_FUNCTION(Set)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_NUMBER);
		gLua->CheckType(3, GLua::TYPE_NUMBER);
		gLua->CheckType(4, GLua::TYPE_NUMBER);

		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);

		cSteamID->Set(gLua->GetInteger(2), (EUniverse)gLua->GetInteger(3), (EAccountType)gLua->GetInteger(4));

		return 0;
	}

	LUA_FUNCTION(SetAccountID)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_NUMBER);

		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);
		
		cSteamID->SetAccountID(gLua->GetInteger(2));

		return 0;
	}

	LUA_FUNCTION(SetEUniverse)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_NUMBER);
		
		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);
		
		cSteamID->SetEUniverse((EUniverse)gLua->GetInteger(2));

		return 0;
	}

	LUA_FUNCTION(__eq)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_ID);

		CSteamID *cSteamID = (CSteamID*)gLua->GetUserData(1);
		CSteamID *cSteamID2 = (CSteamID*)gLua->GetUserData(2);

		if (*cSteamID == *cSteamID2)
			gLua->Push(true);
		else
			gLua->Push(false);

		return 1;
	}
}