#define _MT_CallbackMsg_t gLua->GetMetaTable(MT_CallbackMsg_t::MT_NAME, MT_CallbackMsg_t::MT_ID)

namespace MT_CallbackMsg_t
{
	const char *MT_NAME = "CallbackMsg_t";
	const int MT_ID = 8009;

	LUA_FUNCTION(GetCubParam)
	{
		gLua->CheckType(1, MT_ID);

		CallbackMsg_t *pCallbackMsg = (CallbackMsg_t*)gLua->GetUserData(1);

		gLua->PushDouble(pCallbackMsg->m_cubParam);

		return 1;
	}

	LUA_FUNCTION(GetHSteamUser)
	{
		gLua->CheckType(1, MT_ID);

		CallbackMsg_t *pCallbackMsg = (CallbackMsg_t*)gLua->GetUserData(1);

		HSteamUser *hSteamUser = new HSteamUser(pCallbackMsg->m_hSteamUser);

		gLua->PushUserData(_MT_HSteamUser, hSteamUser);

		return 1;
	}

	LUA_FUNCTION(GetCallback)
	{
		gLua->CheckType(1, MT_ID);

		CallbackMsg_t *pCallbackMsg = (CallbackMsg_t*)gLua->GetUserData(1);

		gLua->PushDouble(pCallbackMsg->m_iCallback);

		return 1;
	}

	LUA_FUNCTION(GetPubParam)
	{
		gLua->CheckType(1, MT_ID);

		CallbackMsg_t *pCallbackMsg = (CallbackMsg_t*)gLua->GetUserData(1);

		gLua->PushUserData(_MT_PubParam, pCallbackMsg->m_pubParam);

		return 1;
	}
}