#define _MT_FriendGameInfo_t gLua->GetMetaTable(MT_FriendGameInfo_t::MT_NAME, MT_FriendGameInfo_t::MT_ID)

namespace MT_FriendGameInfo_t
{
	const char *MT_NAME = "FriendGameInfo_t";
	const int MT_ID = 8006;

	LUA_FUNCTION(GetCGameID)
	{
		gLua->CheckType(1, MT_ID);

		FriendGameInfo_t *gameInfo = (FriendGameInfo_t*)gLua->GetUserData(1);

		CGameID *cGameID = new CGameID(gameInfo->m_gameID);

		gLua->PushUserData(_MT_CGameID, cGameID);

		return 1;
	}

	LUA_FUNCTION(GetGameIP)
	{
		gLua->CheckType(1, MT_ID);

		FriendGameInfo_t *gameInfo = (FriendGameInfo_t*)gLua->GetUserData(1);

		uint8 *ipOctect = (uint8*)&gameInfo->m_unGameIP;

		std::stringstream conIP;
						
		for (int i=3;i>=0;i--)
		{
			conIP << (int)ipOctect[i];

			if (i != 0)
				conIP << ".";
		}

		gLua->Push(conIP.str().c_str());

		return 1;
	}

	LUA_FUNCTION(GetGamePort)
	{
		gLua->CheckType(1, MT_ID);

		FriendGameInfo_t *gameInfo = (FriendGameInfo_t*)gLua->GetUserData(1);

		gLua->PushDouble(gameInfo->m_usGamePort);

		return 1;
	}

	LUA_FUNCTION(GetQueryPort)
	{
		gLua->CheckType(1, MT_ID);

		FriendGameInfo_t *gameInfo = (FriendGameInfo_t*)gLua->GetUserData(1);

		gLua->PushDouble(gameInfo->m_usQueryPort);

		return 1;
	}
}