#define _MT_ISteamClient007 gLua->GetMetaTable(MT_ISteamClient007::MT_NAME, MT_ISteamClient007::MT_ID)

namespace MT_ISteamClient007
{
	const char *MT_NAME = "ISteamClient007";
	const int MT_ID = 8003;

	LUA_FUNCTION(CreateSteamPipe)
	{
		gLua->CheckType(1, MT_ID);

		ISteamClient007 *steamClient = (ISteamClient007*)gLua->GetUserData(1);
		
		HSteamPipe *hSteamPipe = new HSteamPipe(steamClient->CreateSteamPipe());

		gLua->PushUserData(_MT_HSteamPipe, hSteamPipe);	
				
		return 1;
	}

	LUA_FUNCTION(ConnectToGlobalUser)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_HSteamPipe::MT_ID);

		ISteamClient007 *steamClient = (ISteamClient007*)gLua->GetUserData(1);

		HSteamPipe hSteamPipe = *(HSteamPipe*)gLua->GetUserData(2);

		HSteamUser *hSteamUser = new HSteamUser(steamClient->ConnectToGlobalUser(hSteamPipe));

		gLua->PushUserData(_MT_HSteamUser, hSteamUser);

		return 1;
	}

	LUA_FUNCTION(GetISteamUser)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_HSteamUser::MT_ID);
		gLua->CheckType(3, MT_HSteamPipe::MT_ID);
		gLua->CheckType(4, GLua::TYPE_NUMBER);

		ISteamClient007 *steamClient = (ISteamClient007*)gLua->GetUserData(1);

		HSteamUser hSteamUser = *(HSteamUser*)gLua->GetUserData(2);
		HSteamPipe hSteamPipe = *(HSteamPipe*)gLua->GetUserData(3);

		int userVersion = gLua->GetInteger(4);

		switch (userVersion)
		{
			case 5:
			{
				ISteamUser005 *steamUser = (ISteamUser005*)steamClient->GetISteamUser(hSteamUser, hSteamPipe, STEAMUSER_INTERFACE_VERSION_005);
				
				gLua->PushUserData(_MT_ISteamUser005, steamUser);

				break;
			}
			case 12:
			{
				ISteamUser012 *steamUser = (ISteamUser012*)steamClient->GetISteamUser(hSteamUser, hSteamPipe, STEAMUSER_INTERFACE_VERSION_012);
				
				gLua->PushUserData(_MT_ISteamUser012, steamUser);

				break;
			}
			default:
			{
				gLua->PushNil();

				break;
			}
		}

		return 1;
	}

	LUA_FUNCTION(GetISteamFriends)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_HSteamUser::MT_ID);
		gLua->CheckType(3, MT_HSteamPipe::MT_ID);
		gLua->CheckType(4, GLua::TYPE_NUMBER);

		ISteamClient007 *steamClient = (ISteamClient007*)gLua->GetUserData(1);

		HSteamUser hSteamUser = *(HSteamUser*)gLua->GetUserData(2);
		HSteamPipe hSteamPipe = *(HSteamPipe*)gLua->GetUserData(3);
			
		int friendsVersion = gLua->GetInteger(4);

		switch (friendsVersion)
		{
			case 2:
			{
				ISteamFriends002 *steamFriends = (ISteamFriends002*)steamClient->GetISteamFriends(hSteamUser, hSteamPipe, STEAMFRIENDS_INTERFACE_VERSION_002);

				gLua->PushUserData(_MT_ISteamFriends002, steamFriends);

				break;
			}
			case 5:
			{
				ISteamFriends005 *steamFriends = (ISteamFriends005*)steamClient->GetISteamFriends(hSteamUser, hSteamPipe, STEAMFRIENDS_INTERFACE_VERSION_005);

				gLua->PushUserData(_MT_ISteamFriends005, steamFriends);

				break;
			}
			default:
			{
				gLua->PushNil();

				break;
			}
		}

		return 1;
	}
};