#define _MT_ISteamFriends002 gLua->GetMetaTable(MT_ISteamFriends002::MT_NAME, MT_ISteamFriends002::MT_ID)

namespace MT_ISteamFriends002
{
	const char *MT_NAME = "ISteamFriends002";
	const int MT_ID = 8002;

	LUA_FUNCTION(AcknowledgeInviteToClan)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);
		gLua->CheckType(3, GLua::TYPE_BOOL);

		ISteamFriends002 *steamFriends = (ISteamFriends002*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		steamFriends->AcknowledgeInviteToClan(cSteamID, gLua->GetBool(3));

		return 0;
	}

	LUA_FUNCTION(AddFriend)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);

		ISteamFriends002 *steamFriends = (ISteamFriends002*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		gLua->Push(steamFriends->AddFriend(cSteamID));

		return 1;
	}

	LUA_FUNCTION(AddFriendByName)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_STRING);

		ISteamFriends002 *steamFriends = (ISteamFriends002*)gLua->GetUserData(1);

		steamFriends->AddFriendByName(gLua->GetString(2));

		return 0;
	}

	LUA_FUNCTION(GetChatMessage)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);
		gLua->CheckType(3, GLua::TYPE_NUMBER);

		ISteamFriends002 *steamFriends = (ISteamFriends002*)gLua->GetUserData(1);

		CSteamID friendID = *(CSteamID*)gLua->GetUserData(2);
		
		char *pvData = new char[k_cchFriendChatMsgMax];

		EChatEntryType messageType;

		if (steamFriends->GetChatMessage(friendID, gLua->GetInteger(3), pvData, k_cchFriendChatMsgMax, &messageType) != 0)
		{
			ILuaObject *messageTable = gLua->GetNewTable();
				messageTable->SetMember("Body", pvData);
				messageTable->SetMember("Type", (float)messageType);

				gLua->Push(messageTable);
			messageTable->UnReference();
		}
		else
		{
			gLua->PushNil();
		}

		delete[] pvData;

		return 1;
	}

	LUA_FUNCTION(InviteFriendToClan)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);
		gLua->CheckType(3, MT_CSteamID::MT_ID);
		
		ISteamFriends002 *steamFriends = (ISteamFriends002*)gLua->GetUserData(1);

		CSteamID friendID = *(CSteamID*)gLua->GetUserData(2);
		CSteamID groupID = *(CSteamID*)gLua->GetUserData(3);

		steamFriends->InviteFriendToClan(friendID, groupID);

		return 0;
	}

	LUA_FUNCTION(RemoveFriend)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);

		ISteamFriends002 *steamFriends = (ISteamFriends002*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		gLua->Push(steamFriends->RemoveFriend(cSteamID));

		return 1;
	}

	LUA_FUNCTION(SendMsgToFriend)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);
		gLua->CheckType(3, GLua::TYPE_NUMBER);
		gLua->CheckType(4, GLua::TYPE_STRING);

		ISteamFriends002 *steamFriends = (ISteamFriends002*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		gLua->Push(steamFriends->SendMsgToFriend(cSteamID, (EChatEntryType)gLua->GetInteger(3), gLua->GetString(4), gLua->StringLength(4)+1));

		return 0;
	}

	LUA_FUNCTION(SetPersonaState)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_NUMBER);

		ISteamFriends002 *steamFriends = (ISteamFriends002*)gLua->GetUserData(1);

		steamFriends->SetPersonaState((EPersonaState)gLua->GetInteger(2));

		return 0;
	}
}