#define _MT_ISteamFriends005 gLua->GetMetaTable(MT_ISteamFriends005::MT_NAME, MT_ISteamFriends005::MT_ID)

namespace MT_ISteamFriends005
{
	const char *MT_NAME = "ISteamFriends005";
	const int MT_ID = 8001;

	LUA_FUNCTION(ActivateGameOverlay)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_STRING);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);
		
		steamFriends->ActivateGameOverlay(gLua->GetString(1));

		return 0;
	}

	LUA_FUNCTION(ActivateGameOverlayToStore)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_NUMBER);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		steamFriends->ActivateGameOverlayToStore(gLua->GetInteger(2));

		return 0;
	}

	LUA_FUNCTION(ActivateGameOverlayToUser)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_STRING);
		gLua->CheckType(3, MT_CSteamID::MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		steamFriends->ActivateGameOverlayToUser(gLua->GetString(2), cSteamID);

		return 0;
	}

	LUA_FUNCTION(ActivateGameOverlayToWebPage)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_STRING);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		steamFriends->ActivateGameOverlayToWebPage(gLua->GetString(2));

		return 0;
	}

	LUA_FUNCTION(GetClanByIndex)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_NUMBER);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);
		
		CSteamID *cSteamID = new CSteamID(steamFriends->GetClanByIndex(gLua->GetInteger(2)));

		gLua->PushUserData(_MT_CSteamID, cSteamID);
		
		return 1;
	}

	LUA_FUNCTION(GetClanCount)
	{
		gLua->CheckType(1, MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		gLua->PushDouble(steamFriends->GetClanCount());

		return 1;
	}

	LUA_FUNCTION(GetClanName)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		gLua->Push(steamFriends->GetClanName(cSteamID));
		
		return 1;
	}

	LUA_FUNCTION(GetFriendByIndex)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_NUMBER);
		gLua->CheckType(3, GLua::TYPE_NUMBER);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID *cSteamID = new CSteamID(steamFriends->GetFriendByIndex(gLua->GetInteger(2), gLua->GetInteger(3)));
	
		gLua->PushUserData(_MT_CSteamID, cSteamID);

		return 1;
	}

	LUA_FUNCTION(GetFriendCount)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_NUMBER);
		
		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		gLua->PushDouble(steamFriends->GetFriendCount(gLua->GetInteger(2)));

		return 1;
	}

	LUA_FUNCTION(GetFriendCountFromSource)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		gLua->PushDouble(steamFriends->GetFriendCountFromSource(cSteamID));

		return 1;
	}

	LUA_FUNCTION(GetFriendFromSourceByIndex)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);
		gLua->CheckType(3, GLua::TYPE_NUMBER);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID sourceID = *(CSteamID*)gLua->GetUserData(2);

		CSteamID *friendID = new CSteamID(steamFriends->GetFriendFromSourceByIndex(sourceID, gLua->GetInteger(3)));

		gLua->PushUserData(_MT_CSteamID, friendID);

		return 1;
	}

	LUA_FUNCTION(GetFriendGamePlayed)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		FriendGameInfo_t *gameInfo = new FriendGameInfo_t;

		steamFriends->GetFriendGamePlayed(cSteamID, gameInfo);

		gLua->PushUserData(_MT_FriendGameInfo_t, gameInfo);

		return 1;
	}

	LUA_FUNCTION(GetFriendPersonaName)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		gLua->Push(steamFriends->GetFriendPersonaName(cSteamID));

		return 1;
	}

	LUA_FUNCTION(GetFriendPersonaNameHistory)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);
		gLua->CheckType(3, GLua::TYPE_NUMBER);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		gLua->Push(steamFriends->GetFriendPersonaNameHistory(cSteamID, gLua->GetInteger(3)));

		return 1;
	}

	LUA_FUNCTION(GetFriendPersonaState)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		gLua->PushDouble(steamFriends->GetFriendPersonaState(cSteamID));

		return 1;
	}

	LUA_FUNCTION(GetFriendRelationship)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		gLua->PushDouble(steamFriends->GetFriendRelationship(cSteamID));

		return 1;
	}

	LUA_FUNCTION(GetPersonaName)
	{
		gLua->CheckType(1, MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		gLua->Push(steamFriends->GetPersonaName());

		return 1;
	}

	LUA_FUNCTION(GetPersonaState)
	{
		gLua->CheckType(1, MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		gLua->PushDouble(steamFriends->GetPersonaState());

		return 1;
	}

	LUA_FUNCTION(HasFriend)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);
		gLua->CheckType(3, GLua::TYPE_NUMBER);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		gLua->Push(steamFriends->HasFriend(cSteamID, gLua->GetInteger(3)));

		return 1;
	}

	LUA_FUNCTION(IsUserInSource)
	{
		gLua->CheckType(1, MT_ID);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID userID = *(CSteamID*)gLua->GetUserData(2);
		CSteamID sourceID = *(CSteamID*)gLua->GetUserData(3);

		gLua->Push(steamFriends->IsUserInSource(userID, sourceID));

		return 1;
	}

	LUA_FUNCTION(SetInGameVoiceSpeaking)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, MT_CSteamID::MT_ID);
		gLua->CheckType(3, GLua::TYPE_BOOL);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		CSteamID cSteamID = *(CSteamID*)gLua->GetUserData(2);

		steamFriends->SetInGameVoiceSpeaking(cSteamID, gLua->GetBool(3));

		return 0;
	}

	LUA_FUNCTION(SetPersonaName)
	{
		gLua->CheckType(1, MT_ID);
		gLua->CheckType(2, GLua::TYPE_STRING);

		ISteamFriends005 *steamFriends = (ISteamFriends005*)gLua->GetUserData(1);

		steamFriends->SetPersonaName(gLua->GetString(2));
		
		return 0;
	}
}