#include "stdafx.h"

LUA_FUNCTION(CreateCSteamID)
{
	CSteamID *cSteamID = new CSteamID;

	gLua->PushUserData(_MT_CSteamID, cSteamID);

	return 1;
}

LUA_FUNCTION(CreateISteamClient)
{
	gLua->CheckType(1, GLua::TYPE_NUMBER);

	int clientVersion = gLua->GetInteger(1);

	switch (clientVersion)
	{
		case 7:
		{
			ISteamClient007 *steamClient = (ISteamClient007*)steamClientInterface(STEAMCLIENT_INTERFACE_VERSION_007, NULL);
			
			gLua->PushUserData(_MT_ISteamClient007, steamClient);

			break;
		}
		default:
		{
			gLua->PushNil();

			break;
		}
	}
		
	return 1;
}

LUA_FUNCTION(LSteam_BGetCallback)
{
	gLua->CheckType(1, MT_HSteamPipe::MT_ID);

	HSteamPipe hSteamPipe = *(HSteamPipe*)gLua->GetUserData(1);

	CallbackMsg_t *pCallbackMsg = new CallbackMsg_t;

	HSteamCall phSteamCall;

	if (Steam_BGetCallback(hSteamPipe, pCallbackMsg, &phSteamCall))
	{
		gLua->PushUserData(_MT_CallbackMsg_t, pCallbackMsg);
	}	
	else
	{
		gLua->PushNil();

		delete pCallbackMsg;
	}
	
	return 1;
}

LUA_FUNCTION(LSteam_FreeLastCallback)
{
	gLua->CheckType(1, MT_HSteamPipe::MT_ID);

	HSteamPipe hSteamPipe = *(HSteamPipe*)gLua->GetUserData(1);

	Steam_FreeLastCallback(hSteamPipe);

	return 0;
}

int Load(lua_State *L)
{
	gLua = Lua();
	
	steamClientInterface = Sys_GetFactory("steamclient.dll");

	if (!steamClientInterface)
		gLua->Error("Failed to get steamclient.dll interface!");

	gLua->NewGlobalTable("steamworks");

	ILuaObject *steamworksT = gLua->GetGlobal("steamworks");
		steamworksT->SetMember("CSteamID", CreateCSteamID);

		steamworksT->SetMember("ISteamClient", CreateISteamClient);

		steamworksT->SetMember("Steam_BGetCallback", LSteam_BGetCallback);
		steamworksT->SetMember("Steam_FreeLastCallback", LSteam_FreeLastCallback);
	steamworksT->UnReference();

	ILuaObject *metaT = NULL;
	ILuaObject *__index = NULL;

	metaT = _MT_ISteamClient007;
		__index = gLua->GetNewTable();
			__index->SetMember("CreateSteamPipe", MT_ISteamClient007::CreateSteamPipe);
			
			__index->SetMember("ConnectToGlobalUser", MT_ISteamClient007::ConnectToGlobalUser);

			__index->SetMember("GetISteamUser", MT_ISteamClient007::GetISteamUser);
			__index->SetMember("GetISteamFriends", MT_ISteamClient007::GetISteamFriends);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_ISteamUser005;
		__index = gLua->GetNewTable();
			__index->SetMember("GetHSteamUser", MT_ISteamUser005::GetHSteamUser);
			__index->SetMember("GetCSteamID", MT_ISteamUser005::GetCSteamID);

			__index->SetMember("IsPrimaryChatDestination", MT_ISteamUser005::IsPrimaryChatDestination);

			__index->SetMember("LoggedOn", MT_ISteamUser005::LoggedOn);

			__index->SetMember("SetSelfAsPrimaryChatDestination", MT_ISteamUser005::SetSelfAsPrimaryChatDestination);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_ISteamUser012;
		__index = gLua->GetNewTable();
			__index->SetMember("GetHSteamUser", MT_ISteamUser012::GetHSteamUser);
			__index->SetMember("GetCSteamID", MT_ISteamUser012::GetCSteamID);

			__index->SetMember("LoggedOn", MT_ISteamUser012::LoggedOn);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_ISteamFriends002;
		__index = gLua->GetNewTable();
			__index->SetMember("AcknowledgeInviteToClan", MT_ISteamFriends002::AcknowledgeInviteToClan);

			__index->SetMember("AddFriend", MT_ISteamFriends002::AddFriend);
			__index->SetMember("AddFriendByName", MT_ISteamFriends002::AddFriendByName);

			__index->SetMember("GetChatMessage", MT_ISteamFriends002::GetChatMessage);

			__index->SetMember("InviteFriendToClan", MT_ISteamFriends002::InviteFriendToClan);

			__index->SetMember("RemoveFriend", MT_ISteamFriends002::RemoveFriend);

			__index->SetMember("SendMsgToFriend", MT_ISteamFriends002::SendMsgToFriend);

			__index->SetMember("SetPersonaState", MT_ISteamFriends002::SetPersonaState);
			
			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_ISteamFriends005;
		__index = gLua->GetNewTable();
			__index->SetMember("ActivateGameOverlay", MT_ISteamFriends005::ActivateGameOverlay);
			__index->SetMember("ActivateGameOverlayToStore", MT_ISteamFriends005::ActivateGameOverlayToStore);
			__index->SetMember("ActivateGameOverlayToUser", MT_ISteamFriends005::ActivateGameOverlayToUser);
			__index->SetMember("ActivateGameOverlayToWebPage", MT_ISteamFriends005::ActivateGameOverlayToWebPage);

			__index->SetMember("GetClanByIndex", MT_ISteamFriends005::GetClanByIndex);
			__index->SetMember("GetClanCount", MT_ISteamFriends005::GetClanCount);
			__index->SetMember("GetClanName", MT_ISteamFriends005::GetClanName);
			__index->SetMember("GetFriendByIndex", MT_ISteamFriends005::GetFriendByIndex);
			__index->SetMember("GetFriendCount", MT_ISteamFriends005::GetFriendCount);
			__index->SetMember("GetFriendCountFromSource", MT_ISteamFriends005::GetFriendCountFromSource);
			__index->SetMember("GetFriendFromSourceByIndex", MT_ISteamFriends005::GetFriendFromSourceByIndex);
			__index->SetMember("GetFriendGamePlayed", MT_ISteamFriends005::GetFriendGamePlayed);
			__index->SetMember("GetFriendPersonaName", MT_ISteamFriends005::GetFriendPersonaName);
			__index->SetMember("GetFriendPersonaNameHistory", MT_ISteamFriends005::GetFriendPersonaNameHistory);
			__index->SetMember("GetFriendPersonaState", MT_ISteamFriends005::GetFriendPersonaState);
			__index->SetMember("GetFriendRelationship", MT_ISteamFriends005::GetFriendRelationship);
			__index->SetMember("GetPersonaName", MT_ISteamFriends005::GetPersonaName);
			__index->SetMember("GetPersonaState", MT_ISteamFriends005::GetPersonaState);

			__index->SetMember("HasFriend", MT_ISteamFriends005::HasFriend);

			__index->SetMember("IsUserInSource", MT_ISteamFriends005::IsUserInSource);

			__index->SetMember("SetInGameVoiceSpeaking", MT_ISteamFriends005::SetInGameVoiceSpeaking);
			__index->SetMember("SetPersonaName", MT_ISteamFriends005::SetPersonaName);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_CSteamID;
		__index = gLua->GetNewTable();
			__index->SetMember("GetAccountID", MT_CSteamID::GetAccountID);
			__index->SetMember("GetEAccountType", MT_CSteamID::GetEAccountType);
			__index->SetMember("GetEUniverse", MT_CSteamID::GetEUniverse);
			__index->SetMember("GetUnAccountInstance", MT_CSteamID::GetUnAccountInstance);

			__index->SetMember("InstancedSet", MT_CSteamID::InstancedSet);

			__index->SetMember("IsValid", MT_CSteamID::IsValid);

			__index->SetMember("Render", MT_CSteamID::Render);

			__index->SetMember("Set", MT_CSteamID::Set);
			__index->SetMember("SetAccountID", MT_CSteamID::SetAccountID);
			__index->SetMember("SetEUniverse", MT_CSteamID::SetEUniverse);

			metaT->SetMember("__index", __index);
		__index->UnReference();

		metaT->SetMember("__eq", MT_CSteamID::__eq);
	metaT->UnReference();

	metaT = _MT_CallbackMsg_t;
		__index = gLua->GetNewTable();
			__index->SetMember("GetCubParam", MT_CallbackMsg_t::GetCubParam);
			__index->SetMember("GetHSteamUser", MT_CallbackMsg_t::GetHSteamUser);
			__index->SetMember("GetCallback", MT_CallbackMsg_t::GetCallback);
			__index->SetMember("GetPubParam", MT_CallbackMsg_t::GetPubParam);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_PubParam;
		__index = gLua->GetNewTable();
			__index->SetMember("To", MT_PubParam::To);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_GameOverlayActivated_t;
		__index = gLua->GetNewTable();
			__index->SetMember("IsActive", MT_GameOverlayActivated_t::IsActive);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_PersonaStateChange_t;
		__index = gLua->GetNewTable();
			__index->SetMember("GetSteamID", MT_PersonaStateChange_t::GetSteamID);
			__index->SetMember("GetFlags", MT_PersonaStateChange_t::GetFlags);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_FriendChatMsg_t;
		__index = gLua->GetNewTable();
			__index->SetMember("GetReceiver", MT_FriendChatMsg_t::GetReceiver);
			__index->SetMember("GetSender", MT_FriendChatMsg_t::GetSender);
			__index->SetMember("GetChatID", MT_FriendChatMsg_t::GetChatID);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_FriendEndChatSession_t;
		__index = gLua->GetNewTable();
			__index->SetMember("GetCSteamID", MT_FriendEndChatSession_t::GetCSteamID);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_FriendAdded_t;
		__index = gLua->GetNewTable();
			__index->SetMember("GetSuccess", MT_FriendAdded_t::GetSuccess);
			__index->SetMember("GetSteamID", MT_FriendAdded_t::GetSteamID);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_UserRequestingFriendship_t;
		__index = gLua->GetNewTable();
			__index->SetMember("GetSteamID", MT_UserRequestingFriendship_t::GetSteamID);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_FriendGameInfo_t;
		__index = gLua->GetNewTable();
			__index->SetMember("GetCGameID", MT_FriendGameInfo_t::GetCGameID);
			__index->SetMember("GetGameIP", MT_FriendGameInfo_t::GetGameIP);
			__index->SetMember("GetGamePort", MT_FriendGameInfo_t::GetGamePort);
			__index->SetMember("GetQueryPort", MT_FriendGameInfo_t::GetQueryPort);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	metaT = _MT_CGameID;
		__index = gLua->GetNewTable();
			__index->SetMember("AppID", MT_CGameID::AppID);
			
			__index->SetMember("IsMod", MT_CGameID::IsMod);
			__index->SetMember("IsP2PFile", MT_CGameID::IsP2PFile);
			__index->SetMember("IsShortcut", MT_CGameID::IsShortcut);
			__index->SetMember("IsSteamApp", MT_CGameID::IsSteamApp);
			__index->SetMember("IsValid", MT_CGameID::IsValid);

			__index->SetMember("ModID", MT_CGameID::ModID);

			metaT->SetMember("__index", __index);
		__index->UnReference();
	metaT->UnReference();

	return 0;
}

int Unload(lua_State *L)
{
	return 0;
}